MODULE YEMLAP

USE PARKIND1  ,ONLY : JPIM     ,JPRB

IMPLICIT NONE

SAVE

!     ------------------------------------------------------------------
!*    Constants related to the Laplace space

!  NCPL2M :  number of complex Laplace coefficient for m given (local)
!  NCPL4M :  number of real    Laplace coefficient for m given (local)
!  NCPLM  :  number of complex real/imag. Laplace coefficient for m given
!            (half of NCPL2M)
INTEGER(KIND=JPIM),ALLOCATABLE:: NCPL2M(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NCPL4M(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NCPLM(:)
!  NCPL2N :  number of complex Laplace coefficient for n given
!  NCPL4N :  number of real    Laplace coefficient for n given
!  NCPLN  :  number of complex real/imag. coefficient for n given
!            (half of NCPL2N)
INTEGER(KIND=JPIM),ALLOCATABLE:: NCPL2N(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NCPL4N(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NCPLN(:)
!  RLEPDIN:  eigen-values of the Laplace operator
!  RLEPINN:  eigen-values of its inverse
REAL(KIND=JPRB),ALLOCATABLE:: RLEPDIN(:)
REAL(KIND=JPRB),ALLOCATABLE:: RLEPINN(:)
!  RLEPDIM:  eigen-values of the Laplace operator
!  RLEPINM:  eigen-values of its inverse
REAL(KIND=JPRB),ALLOCATABLE:: RLEPDIM(:)
REAL(KIND=JPRB),ALLOCATABLE:: RLEPINM(:)
!  NESM0 : address (local) in a spectral array of (n, m=0)
!  NESM0G: address (global) in a spectral array of (n, m=0)
!  NESRN : number of real (and imaginary) Laplace coefficients
!          for n given and m different from 0
!  NESPZERO: global adresses in the (global-dimensioned) spectral arrays
!            of those coefficients which are always zero, id est:
!            m = 0 - coefficients 3 and 4 for every quadruplet (1,2,3,4)
!            n = 0 - coefficients 2 and 4 for every quadruplet (1,2,3,4)
INTEGER(KIND=JPIM),ALLOCATABLE:: NESM0(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NESRN(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NESPZERO(:)
INTEGER(KIND=JPIM),ALLOCATABLE:: NESM0G(:)

!  NPME  : address for the Laplace operator and its inverse
INTEGER(KIND=JPIM),ALLOCATABLE:: NPME(:)
!  NPNE  : address for the Laplace operator and its inverse
INTEGER(KIND=JPIM),ALLOCATABLE:: NPNE(:)
!  MVALUE: wavenumber M for the given spectral coefficient
INTEGER(KIND=JPIM),ALLOCATABLE:: MVALUE(:)

!        POINTER STATEMENTS

! pruned !!

!     ------------------------------------------------------------------
END MODULE YEMLAP
